#ifndef FIN_EL_NET_STRUCTURES_H
#define FIN_EL_NET_STRUCTURES_H
#include <vector>
#include <set>
#include <map>
#include "iostream"

using namespace std;

//!!! Между объявлениями должна быть 1-2 строки для лучшей читаемости

struct Node{
    int id;
    double x, y, z;
    bool is_summit;
    friend std::ostream &operator<<(std::ostream &, const Node &);
    friend std::ostream &operator<<(std::ostream &, const vector<Node> &);
    friend std::ostream &operator<<(std::ostream &, const set<Node> &);
    friend std::ostream &operator<<(std::ostream &, const map<int,Node> &);
    
    friend bool operator <(const Node &lhs, const Node &rhs)
    { 
        return lhs.id < rhs.id; 
    };
    
    friend bool operator >(const Node &lhs, const Node &rhs)
    { 
        return lhs.id > rhs.id; 
    };
};

struct FiniteElement{
    int fe_id;
    int mat_id;
    vector <int> nodes_id;

    friend std::ostream &operator<<(std::ostream &, const FiniteElement &);
    friend std::ostream &operator<<(std::ostream &, const std::vector<FiniteElement> &);
};

struct BoundaryFiniteElement : public FiniteElement{
    int bfe_id;
    int border_id;

    friend std::ostream &operator<<(std::ostream &, const BoundaryFiniteElement &);
    friend std::ostream &operator<<(std::ostream &, const std::vector<BoundaryFiniteElement> &);
};
#endif //FIN_EL_NET_STRUCTURES_H
